/*
 *	Copyright (C) 2008, 2009. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */


#include "cameradialog.h"
#include <qvcore/qvcamera.h>


CameraDialog::CameraDialog(QVCamera* camera, QWidget *parent): QDialog(parent), inspector(camera, this), interface(camera)
{
	setWindowTitle(camera->getName());

	vboxlayout = new QVBoxLayout();
	vboxlayout->addWidget(&inspector);
	vboxlayout->addWidget(&interface);
	vboxlayout->setAlignment(&interface, Qt::AlignHCenter);

	connect(camera, SIGNAL(camOpened()), this, SLOT(disableInspector()));
	connect(camera, SIGNAL(camClosed()), this, SLOT(enableInspector()));

	setLayout(vboxlayout);
}

void CameraDialog::enableInspector()
{
	inspector.setEnabled(TRUE);
}

void CameraDialog::disableInspector()
{
	inspector.setEnabled(FALSE);
}

