/*
 *	Copyright (C) 2007, 2008, 2009. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file qvippworkers.cpp
/// @brief File from the QVision library.
/// @author PARP Research Group. University of Murcia, Spain.

#include <qvworkers/qvippworkers.h>

const QMap<QString, QString> getQVIPPWorkersNames()
	{
	QMap<QString, QString> result;

	result.insertMulti("IPP: Image Data Exchange and Initialization Functions", "QVConvert_uCharsFloatC1Worker");
	result.insertMulti("IPP: Image Data Exchange and Initialization Functions", "QVConvert_uCharsFloatC3Worker");
	result.insertMulti("IPP: Image Data Exchange and Initialization Functions", "QVConvert_sFloatuCharC1Worker");
	result.insertMulti("IPP: Image Data Exchange and Initialization Functions", "QVConvert_sFloatuCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAdd_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAdd_uCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAdd_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAdd_sFloatC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAddC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAddC_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMul_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMul_uCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMul_sFloatC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMul_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMulC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMulC_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMulScale_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVMulScale_uCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSub_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSub_uCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSub_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSub_sFloatC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSubC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSubC_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVDiv_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVDiv_uCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVDiv_sFloatC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVDiv_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVDivC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVDivC_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAbs_sShortC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAbs_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAbsDiff_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAbsDiff_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVSqr_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVLn_sFloatC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVLn_sFloatC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVAndC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVNot_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVNot_uCharC3Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVOrC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVXorC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVLShiftC_uCharC1Worker");
	result.insertMulti("IPP: Image Arithmetic and Logical Operations", "QVRShiftC_uCharC1Worker");
	result.insertMulti("IPP: Image Color Conversion", "QVRGBToGray_uCharC3C1Worker");
	result.insertMulti("IPP: Image Color Conversion", "QVRGBToGray_sFloatC3C1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVThreshold_uCharC1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVThreshold_sFloatC1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVComputeThreshold_Otsu_uCharC1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVCompare_uCharC1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVCompare_sFloatC1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVCompareC_uCharC1Worker");
	result.insertMulti("IPP: Threshold and Compare Operations", "QVCompareC_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterBox_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterBox_uCharC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterBox_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMin_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMin_uCharC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMin_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMax_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMax_uCharC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMax_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMedian_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMedian_uCharC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterMedianHoriz_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterSobelHorizMask_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterSobelVertMask_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterLaplace_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterLaplace_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterGauss_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterGauss_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterGauss_uCharC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterGauss_sFloatC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterHipass_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterHipass_uCharC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterHipass_sFloatC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterHipass_sFloatC3Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterLowpass_uCharC1Worker");
	result.insertMulti("IPP: Filtering Functions", "QVFilterLowpass_sFloatC1Worker");
	result.insertMulti("IPP: Image Statistics Functions", "QVSum_uCharC1Worker");
	result.insertMulti("IPP: Image Statistics Functions", "QVMean_uCharC1Worker");
	result.insertMulti("IPP: Image Statistics Functions", "QVMin_uCharC1Worker");
	result.insertMulti("IPP: Image Statistics Functions", "QVMin_sFloatC1Worker");
	result.insertMulti("IPP: Image Statistics Functions", "QVMax_uCharC1Worker");
	result.insertMulti("IPP: Image Statistics Functions", "QVMax_sFloatC1Worker");

	return result;
	}

QVPropertyContainer *newQVIPPWorker(QString type, QString name)
	{
	if (type == "QVConvert_uCharsFloatC1Worker")			return new QVConvert_uCharsFloatC1Worker(name);
	else if (type == "QVConvert_uCharsFloatC3Worker")			return new QVConvert_uCharsFloatC3Worker(name);
	else if (type == "QVConvert_sFloatuCharC1Worker")			return new QVConvert_sFloatuCharC1Worker(name);
	else if (type == "QVConvert_sFloatuCharC3Worker")			return new QVConvert_sFloatuCharC3Worker(name);
	else if (type == "QVAdd_uCharC1Worker")			return new QVAdd_uCharC1Worker(name);
	else if (type == "QVAdd_uCharC3Worker")			return new QVAdd_uCharC3Worker(name);
	else if (type == "QVAdd_sFloatC1Worker")			return new QVAdd_sFloatC1Worker(name);
	else if (type == "QVAdd_sFloatC3Worker")			return new QVAdd_sFloatC3Worker(name);
	else if (type == "QVAddC_uCharC1Worker")			return new QVAddC_uCharC1Worker(name);
	else if (type == "QVAddC_sFloatC1Worker")			return new QVAddC_sFloatC1Worker(name);
	else if (type == "QVMul_uCharC1Worker")			return new QVMul_uCharC1Worker(name);
	else if (type == "QVMul_uCharC3Worker")			return new QVMul_uCharC3Worker(name);
	else if (type == "QVMul_sFloatC3Worker")			return new QVMul_sFloatC3Worker(name);
	else if (type == "QVMul_sFloatC1Worker")			return new QVMul_sFloatC1Worker(name);
	else if (type == "QVMulC_uCharC1Worker")			return new QVMulC_uCharC1Worker(name);
	else if (type == "QVMulC_sFloatC1Worker")			return new QVMulC_sFloatC1Worker(name);
	else if (type == "QVMulScale_uCharC1Worker")			return new QVMulScale_uCharC1Worker(name);
	else if (type == "QVMulScale_uCharC3Worker")			return new QVMulScale_uCharC3Worker(name);
	else if (type == "QVSub_uCharC1Worker")			return new QVSub_uCharC1Worker(name);
	else if (type == "QVSub_uCharC3Worker")			return new QVSub_uCharC3Worker(name);
	else if (type == "QVSub_sFloatC1Worker")			return new QVSub_sFloatC1Worker(name);
	else if (type == "QVSub_sFloatC3Worker")			return new QVSub_sFloatC3Worker(name);
	else if (type == "QVSubC_uCharC1Worker")			return new QVSubC_uCharC1Worker(name);
	else if (type == "QVSubC_sFloatC1Worker")			return new QVSubC_sFloatC1Worker(name);
	else if (type == "QVDiv_uCharC1Worker")			return new QVDiv_uCharC1Worker(name);
	else if (type == "QVDiv_uCharC3Worker")			return new QVDiv_uCharC3Worker(name);
	else if (type == "QVDiv_sFloatC3Worker")			return new QVDiv_sFloatC3Worker(name);
	else if (type == "QVDiv_sFloatC1Worker")			return new QVDiv_sFloatC1Worker(name);
	else if (type == "QVDivC_uCharC1Worker")			return new QVDivC_uCharC1Worker(name);
	else if (type == "QVDivC_sFloatC1Worker")			return new QVDivC_sFloatC1Worker(name);
	else if (type == "QVAbs_sShortC1Worker")			return new QVAbs_sShortC1Worker(name);
	else if (type == "QVAbs_sFloatC1Worker")			return new QVAbs_sFloatC1Worker(name);
	else if (type == "QVAbsDiff_uCharC1Worker")			return new QVAbsDiff_uCharC1Worker(name);
	else if (type == "QVAbsDiff_sFloatC1Worker")			return new QVAbsDiff_sFloatC1Worker(name);
	else if (type == "QVSqr_sFloatC1Worker")			return new QVSqr_sFloatC1Worker(name);
	else if (type == "QVLn_sFloatC1Worker")			return new QVLn_sFloatC1Worker(name);
	else if (type == "QVLn_sFloatC3Worker")			return new QVLn_sFloatC3Worker(name);
	else if (type == "QVAndC_uCharC1Worker")			return new QVAndC_uCharC1Worker(name);
	else if (type == "QVNot_uCharC1Worker")			return new QVNot_uCharC1Worker(name);
	else if (type == "QVNot_uCharC3Worker")			return new QVNot_uCharC3Worker(name);
	else if (type == "QVOrC_uCharC1Worker")			return new QVOrC_uCharC1Worker(name);
	else if (type == "QVXorC_uCharC1Worker")			return new QVXorC_uCharC1Worker(name);
	else if (type == "QVLShiftC_uCharC1Worker")			return new QVLShiftC_uCharC1Worker(name);
	else if (type == "QVRShiftC_uCharC1Worker")			return new QVRShiftC_uCharC1Worker(name);
	else if (type == "QVRGBToGray_uCharC3C1Worker")			return new QVRGBToGray_uCharC3C1Worker(name);
	else if (type == "QVRGBToGray_sFloatC3C1Worker")			return new QVRGBToGray_sFloatC3C1Worker(name);
	else if (type == "QVThreshold_uCharC1Worker")			return new QVThreshold_uCharC1Worker(name);
	else if (type == "QVThreshold_sFloatC1Worker")			return new QVThreshold_sFloatC1Worker(name);
	else if (type == "QVComputeThreshold_Otsu_uCharC1Worker")			return new QVComputeThreshold_Otsu_uCharC1Worker(name);
	else if (type == "QVCompare_uCharC1Worker")			return new QVCompare_uCharC1Worker(name);
	else if (type == "QVCompare_sFloatC1Worker")			return new QVCompare_sFloatC1Worker(name);
	else if (type == "QVCompareC_uCharC1Worker")			return new QVCompareC_uCharC1Worker(name);
	else if (type == "QVCompareC_sFloatC1Worker")			return new QVCompareC_sFloatC1Worker(name);
	else if (type == "QVFilterBox_uCharC1Worker")			return new QVFilterBox_uCharC1Worker(name);
	else if (type == "QVFilterBox_uCharC3Worker")			return new QVFilterBox_uCharC3Worker(name);
	else if (type == "QVFilterBox_sFloatC1Worker")			return new QVFilterBox_sFloatC1Worker(name);
	else if (type == "QVFilterMin_uCharC1Worker")			return new QVFilterMin_uCharC1Worker(name);
	else if (type == "QVFilterMin_uCharC3Worker")			return new QVFilterMin_uCharC3Worker(name);
	else if (type == "QVFilterMin_sFloatC1Worker")			return new QVFilterMin_sFloatC1Worker(name);
	else if (type == "QVFilterMax_uCharC1Worker")			return new QVFilterMax_uCharC1Worker(name);
	else if (type == "QVFilterMax_uCharC3Worker")			return new QVFilterMax_uCharC3Worker(name);
	else if (type == "QVFilterMax_sFloatC1Worker")			return new QVFilterMax_sFloatC1Worker(name);
	else if (type == "QVFilterMedian_uCharC1Worker")			return new QVFilterMedian_uCharC1Worker(name);
	else if (type == "QVFilterMedian_uCharC3Worker")			return new QVFilterMedian_uCharC3Worker(name);
	else if (type == "QVFilterMedianHoriz_uCharC1Worker")			return new QVFilterMedianHoriz_uCharC1Worker(name);
	else if (type == "QVFilterSobelHorizMask_sFloatC1Worker")			return new QVFilterSobelHorizMask_sFloatC1Worker(name);
	else if (type == "QVFilterSobelVertMask_sFloatC1Worker")			return new QVFilterSobelVertMask_sFloatC1Worker(name);
	else if (type == "QVFilterLaplace_uCharC1Worker")			return new QVFilterLaplace_uCharC1Worker(name);
	else if (type == "QVFilterLaplace_sFloatC1Worker")			return new QVFilterLaplace_sFloatC1Worker(name);
	else if (type == "QVFilterGauss_uCharC1Worker")			return new QVFilterGauss_uCharC1Worker(name);
	else if (type == "QVFilterGauss_sFloatC1Worker")			return new QVFilterGauss_sFloatC1Worker(name);
	else if (type == "QVFilterGauss_uCharC3Worker")			return new QVFilterGauss_uCharC3Worker(name);
	else if (type == "QVFilterGauss_sFloatC3Worker")			return new QVFilterGauss_sFloatC3Worker(name);
	else if (type == "QVFilterHipass_uCharC1Worker")			return new QVFilterHipass_uCharC1Worker(name);
	else if (type == "QVFilterHipass_uCharC3Worker")			return new QVFilterHipass_uCharC3Worker(name);
	else if (type == "QVFilterHipass_sFloatC1Worker")			return new QVFilterHipass_sFloatC1Worker(name);
	else if (type == "QVFilterHipass_sFloatC3Worker")			return new QVFilterHipass_sFloatC3Worker(name);
	else if (type == "QVFilterLowpass_uCharC1Worker")			return new QVFilterLowpass_uCharC1Worker(name);
	else if (type == "QVFilterLowpass_sFloatC1Worker")			return new QVFilterLowpass_sFloatC1Worker(name);
	else if (type == "QVSum_uCharC1Worker")			return new QVSum_uCharC1Worker(name);
	else if (type == "QVMean_uCharC1Worker")			return new QVMean_uCharC1Worker(name);
	else if (type == "QVMin_uCharC1Worker")			return new QVMin_uCharC1Worker(name);
	else if (type == "QVMin_sFloatC1Worker")			return new QVMin_sFloatC1Worker(name);
	else if (type == "QVMax_uCharC1Worker")			return new QVMax_uCharC1Worker(name);
	else if (type == "QVMax_sFloatC1Worker")			return new QVMax_sFloatC1Worker(name);
	else return NULL;
	}

// Worker QVConvert_uCharsFloatC1Worker for IPP function ippiConvert_8u32f_C1R
QVConvert_uCharsFloatC1Worker::QVConvert_uCharsFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVConvert_uCharsFloatC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Convert(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVConvert_uCharsFloatC3Worker for IPP function ippiConvert_8u32f_C3R
QVConvert_uCharsFloatC3Worker::QVConvert_uCharsFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVConvert_uCharsFloatC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	Convert(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVConvert_sFloatuCharC1Worker for IPP function ippiConvert_32f8u_C1R
QVConvert_sFloatuCharC1Worker::QVConvert_sFloatuCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppRoundMode >("roundMode", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVConvert_sFloatuCharC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppRoundMode roundMode = getPropertyValue< IppRoundMode > ("roundMode");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Convert(qvimage_pSrc, qvimage_pDst, roundMode, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVConvert_sFloatuCharC3Worker for IPP function ippiConvert_32f8u_C3R
QVConvert_sFloatuCharC3Worker::QVConvert_sFloatuCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< IppRoundMode >("roundMode", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVConvert_sFloatuCharC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc");
	const IppRoundMode roundMode = getPropertyValue< IppRoundMode > ("roundMode");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	Convert(qvimage_pSrc, qvimage_pDst, roundMode, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAdd_uCharC1Worker for IPP function ippiAdd_8u_C1RSfs
QVAdd_uCharC1Worker::QVAdd_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAdd_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Add(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAdd_uCharC3Worker for IPP function ippiAdd_8u_C3RSfs
QVAdd_uCharC3Worker::QVAdd_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAdd_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc1");
	const QVImage<uChar, 3> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	Add(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAdd_sFloatC1Worker for IPP function ippiAdd_32f_C1R
QVAdd_sFloatC1Worker::QVAdd_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAdd_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc1");
	const QVImage<sFloat, 1> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Add(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAdd_sFloatC3Worker for IPP function ippiAdd_32f_C3R
QVAdd_sFloatC3Worker::QVAdd_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAdd_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc1");
	const QVImage<sFloat, 3> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	Add(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAddC_uCharC1Worker for IPP function ippiAddC_8u_C1RSfs
QVAddC_uCharC1Worker::QVAddC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAddC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	AddC(qvimage_pSrc, value, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAddC_sFloatC1Worker for IPP function ippiAddC_32f_C1R
QVAddC_sFloatC1Worker::QVAddC_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("value", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAddC_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const sFloat value = getPropertyValue< sFloat > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	AddC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMul_uCharC1Worker for IPP function ippiMul_8u_C1RSfs
QVMul_uCharC1Worker::QVMul_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMul_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Mul(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMul_uCharC3Worker for IPP function ippiMul_8u_C3RSfs
QVMul_uCharC3Worker::QVMul_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMul_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc1");
	const QVImage<uChar, 3> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	Mul(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMul_sFloatC3Worker for IPP function ippiMul_32f_C3R
QVMul_sFloatC3Worker::QVMul_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMul_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc1");
	const QVImage<sFloat, 3> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	Mul(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMul_sFloatC1Worker for IPP function ippiMul_32f_C1R
QVMul_sFloatC1Worker::QVMul_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMul_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc1");
	const QVImage<sFloat, 1> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Mul(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMulC_uCharC1Worker for IPP function ippiMulC_8u_C1RSfs
QVMulC_uCharC1Worker::QVMulC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMulC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	MulC(qvimage_pSrc, value, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMulC_sFloatC1Worker for IPP function ippiMulC_32f_C1R
QVMulC_sFloatC1Worker::QVMulC_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("value", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMulC_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const sFloat value = getPropertyValue< sFloat > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	MulC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMulScale_uCharC1Worker for IPP function ippiMulScale_8u_C1R
QVMulScale_uCharC1Worker::QVMulScale_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMulScale_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	MulScale(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVMulScale_uCharC3Worker for IPP function ippiMulScale_8u_C3R
QVMulScale_uCharC3Worker::QVMulScale_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVMulScale_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc1");
	const QVImage<uChar, 3> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	MulScale(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSub_uCharC1Worker for IPP function ippiSub_8u_C1RSfs
QVSub_uCharC1Worker::QVSub_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSub_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Sub(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSub_uCharC3Worker for IPP function ippiSub_8u_C3RSfs
QVSub_uCharC3Worker::QVSub_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSub_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc1");
	const QVImage<uChar, 3> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	Sub(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSub_sFloatC1Worker for IPP function ippiSub_32f_C1R
QVSub_sFloatC1Worker::QVSub_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSub_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc1");
	const QVImage<sFloat, 1> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Sub(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSub_sFloatC3Worker for IPP function ippiSub_32f_C3R
QVSub_sFloatC3Worker::QVSub_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSub_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc1");
	const QVImage<sFloat, 3> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	Sub(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSubC_uCharC1Worker for IPP function ippiSubC_8u_C1RSfs
QVSubC_uCharC1Worker::QVSubC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSubC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	SubC(qvimage_pSrc, value, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSubC_sFloatC1Worker for IPP function ippiSubC_32f_C1R
QVSubC_sFloatC1Worker::QVSubC_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("value", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSubC_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const sFloat value = getPropertyValue< sFloat > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	SubC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVDiv_uCharC1Worker for IPP function ippiDiv_8u_C1RSfs
QVDiv_uCharC1Worker::QVDiv_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVDiv_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Div(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVDiv_uCharC3Worker for IPP function ippiDiv_8u_C3RSfs
QVDiv_uCharC3Worker::QVDiv_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVDiv_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc1");
	const QVImage<uChar, 3> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc2");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	Div(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVDiv_sFloatC3Worker for IPP function ippiDiv_32f_C3R
QVDiv_sFloatC3Worker::QVDiv_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVDiv_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc1");
	const QVImage<sFloat, 3> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	Div(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVDiv_sFloatC1Worker for IPP function ippiDiv_32f_C1R
QVDiv_sFloatC1Worker::QVDiv_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVDiv_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc1");
	const QVImage<sFloat, 1> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Div(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVDivC_uCharC1Worker for IPP function ippiDivC_8u_C1RSfs
QVDivC_uCharC1Worker::QVDivC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< int >("scaleFactor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVDivC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const int scaleFactor = getPropertyValue< int > ("scaleFactor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	DivC(qvimage_pSrc, value, qvimage_pDst, scaleFactor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVDivC_sFloatC1Worker for IPP function ippiDivC_32f_C1R
QVDivC_sFloatC1Worker::QVDivC_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("value", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVDivC_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const sFloat value = getPropertyValue< sFloat > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	DivC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAbs_sShortC1Worker for IPP function ippiAbs_16s_C1R
QVAbs_sShortC1Worker::QVAbs_sShortC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sShort, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sShort, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAbs_sShortC1Worker::iterate()
	{
	const QVImage<sShort, 1> qvimage_pSrc = getPropertyValue< QVImage<sShort, 1> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sShort, 1> qvimage_pDst;

	Abs(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sShort, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAbs_sFloatC1Worker for IPP function ippiAbs_32f_C1R
QVAbs_sFloatC1Worker::QVAbs_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAbs_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Abs(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAbsDiff_uCharC1Worker for IPP function ippiAbsDiff_8u_C1R
QVAbsDiff_uCharC1Worker::QVAbsDiff_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAbsDiff_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	AbsDiff(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAbsDiff_sFloatC1Worker for IPP function ippiAbsDiff_32f_C1R
QVAbsDiff_sFloatC1Worker::QVAbsDiff_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAbsDiff_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc1");
	const QVImage<sFloat, 1> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc2");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	AbsDiff(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSqr_sFloatC1Worker for IPP function ippiSqr_32f_C1R
QVSqr_sFloatC1Worker::QVSqr_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVSqr_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Sqr(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVLn_sFloatC1Worker for IPP function ippiLn_32f_C1R
QVLn_sFloatC1Worker::QVLn_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVLn_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Ln(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVLn_sFloatC3Worker for IPP function ippiLn_32f_C3R
QVLn_sFloatC3Worker::QVLn_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVLn_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	Ln(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVAndC_uCharC1Worker for IPP function ippiAndC_8u_C1R
QVAndC_uCharC1Worker::QVAndC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVAndC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	AndC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVNot_uCharC1Worker for IPP function ippiNot_8u_C1R
QVNot_uCharC1Worker::QVNot_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVNot_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Not(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVNot_uCharC3Worker for IPP function ippiNot_8u_C3R
QVNot_uCharC3Worker::QVNot_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVNot_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	Not(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVOrC_uCharC1Worker for IPP function ippiOrC_8u_C1R
QVOrC_uCharC1Worker::QVOrC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVOrC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	OrC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVXorC_uCharC1Worker for IPP function ippiXorC_8u_C1R
QVXorC_uCharC1Worker::QVXorC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVXorC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	XorC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVLShiftC_uCharC1Worker for IPP function ippiLShiftC_8u_C1R
QVLShiftC_uCharC1Worker::QVLShiftC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uInt >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVLShiftC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uInt value = getPropertyValue< uInt > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	LShiftC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVRShiftC_uCharC1Worker for IPP function ippiRShiftC_8u_C1R
QVRShiftC_uCharC1Worker::QVRShiftC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uInt >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVRShiftC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uInt value = getPropertyValue< uInt > ("value");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	RShiftC(qvimage_pSrc, value, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVRGBToGray_uCharC3C1Worker for IPP function ippiRGBToGray_8u_C3C1R
QVRGBToGray_uCharC3C1Worker::QVRGBToGray_uCharC3C1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVRGBToGray_uCharC3C1Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	RGBToGray(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVRGBToGray_sFloatC3C1Worker for IPP function ippiRGBToGray_32f_C3C1R
QVRGBToGray_sFloatC3C1Worker::QVRGBToGray_sFloatC3C1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVRGBToGray_sFloatC3C1Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	RGBToGray(qvimage_pSrc, qvimage_pDst, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVThreshold_uCharC1Worker for IPP function ippiThreshold_8u_C1R
QVThreshold_uCharC1Worker::QVThreshold_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< uChar >("threshold", inputFlag);
	addProperty< IppCmpOp >("ippCmpOp", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVThreshold_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar threshold = getPropertyValue< uChar > ("threshold");
	const IppCmpOp ippCmpOp = getPropertyValue< IppCmpOp > ("ippCmpOp");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Threshold(qvimage_pSrc, qvimage_pDst, threshold, ippCmpOp, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVThreshold_sFloatC1Worker for IPP function ippiThreshold_32f_C1R
QVThreshold_sFloatC1Worker::QVThreshold_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< sFloat >("threshold", inputFlag);
	addProperty< IppCmpOp >("ippCmpOp", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVThreshold_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const sFloat threshold = getPropertyValue< sFloat > ("threshold");
	const IppCmpOp ippCmpOp = getPropertyValue< IppCmpOp > ("ippCmpOp");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	Threshold(qvimage_pSrc, qvimage_pDst, threshold, ippCmpOp, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVComputeThreshold_Otsu_uCharC1Worker for IPP function ippiComputeThreshold_Otsu_8u_C1R
QVComputeThreshold_Otsu_uCharC1Worker::QVComputeThreshold_Otsu_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("pThreshold", outputFlag);
	}

void QVComputeThreshold_Otsu_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");

	uChar pThreshold;

	ComputeThreshold_Otsu(qvimage_pSrc, pThreshold);

	setPropertyValue< uChar >("pThreshold", pThreshold);
	}

// Worker QVCompare_uCharC1Worker for IPP function ippiCompare_8u_C1R
QVCompare_uCharC1Worker::QVCompare_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppCmpOp >("ippCmpOp", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVCompare_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc1 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc1");
	const QVImage<uChar, 1> qvimage_pSrc2 = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc2");
	const IppCmpOp ippCmpOp = getPropertyValue< IppCmpOp > ("ippCmpOp");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Compare(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, ippCmpOp, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVCompare_sFloatC1Worker for IPP function ippiCompare_32f_C1R
QVCompare_sFloatC1Worker::QVCompare_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc1", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc2", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppCmpOp >("ippCmpOp", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVCompare_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc1 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc1");
	const QVImage<sFloat, 1> qvimage_pSrc2 = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc2");
	const IppCmpOp ippCmpOp = getPropertyValue< IppCmpOp > ("ippCmpOp");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	Compare(qvimage_pSrc1, qvimage_pSrc2, qvimage_pDst, ippCmpOp, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVCompareC_uCharC1Worker for IPP function ippiCompareC_8u_C1R
QVCompareC_uCharC1Worker::QVCompareC_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppCmpOp >("ippCmpOp", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVCompareC_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const uChar value = getPropertyValue< uChar > ("value");
	const IppCmpOp ippCmpOp = getPropertyValue< IppCmpOp > ("ippCmpOp");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	CompareC(qvimage_pSrc, value, qvimage_pDst, ippCmpOp, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVCompareC_sFloatC1Worker for IPP function ippiCompareC_32f_C1R
QVCompareC_sFloatC1Worker::QVCompareC_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("value", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppCmpOp >("ippCmpOp", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVCompareC_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const sFloat value = getPropertyValue< sFloat > ("value");
	const IppCmpOp ippCmpOp = getPropertyValue< IppCmpOp > ("ippCmpOp");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	CompareC(qvimage_pSrc, value, qvimage_pDst, ippCmpOp, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterBox_uCharC1Worker for IPP function ippiFilterBox_8u_C1R
QVFilterBox_uCharC1Worker::QVFilterBox_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterBox_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterBox(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterBox_uCharC3Worker for IPP function ippiFilterBox_8u_C3R
QVFilterBox_uCharC3Worker::QVFilterBox_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterBox_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	FilterBox(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterBox_sFloatC1Worker for IPP function ippiFilterBox_32f_C1R
QVFilterBox_sFloatC1Worker::QVFilterBox_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterBox_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterBox(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMin_uCharC1Worker for IPP function ippiFilterMin_8u_C1R
QVFilterMin_uCharC1Worker::QVFilterMin_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMin_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterMin(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMin_uCharC3Worker for IPP function ippiFilterMin_8u_C3R
QVFilterMin_uCharC3Worker::QVFilterMin_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMin_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	FilterMin(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMin_sFloatC1Worker for IPP function ippiFilterMin_32f_C1R
QVFilterMin_sFloatC1Worker::QVFilterMin_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMin_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterMin(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMax_uCharC1Worker for IPP function ippiFilterMax_8u_C1R
QVFilterMax_uCharC1Worker::QVFilterMax_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMax_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterMax(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMax_uCharC3Worker for IPP function ippiFilterMax_8u_C3R
QVFilterMax_uCharC3Worker::QVFilterMax_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMax_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	FilterMax(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMax_sFloatC1Worker for IPP function ippiFilterMax_32f_C1R
QVFilterMax_sFloatC1Worker::QVFilterMax_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMax_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterMax(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMedian_uCharC1Worker for IPP function ippiFilterMedian_8u_C1R
QVFilterMedian_uCharC1Worker::QVFilterMedian_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMedian_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterMedian(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMedian_uCharC3Worker for IPP function ippiFilterMedian_8u_C3R
QVFilterMedian_uCharC3Worker::QVFilterMedian_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< QSize >("maskSize", inputFlag);
	addProperty< QPoint >("anchor", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMedian_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const QSize maskSize = getPropertyValue< QSize > ("maskSize");
	const QPoint anchor = getPropertyValue< QPoint > ("anchor");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	FilterMedian(qvimage_pSrc, qvimage_pDst, maskSize, anchor, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterMedianHoriz_uCharC1Worker for IPP function ippiFilterMedianHoriz_8u_C1R
QVFilterMedianHoriz_uCharC1Worker::QVFilterMedianHoriz_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterMedianHoriz_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterMedianHoriz(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterSobelHorizMask_sFloatC1Worker for IPP function ippiFilterSobelHorizMask_32f_C1R
QVFilterSobelHorizMask_sFloatC1Worker::QVFilterSobelHorizMask_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterSobelHorizMask_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterSobelHorizMask(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterSobelVertMask_sFloatC1Worker for IPP function ippiFilterSobelVertMask_32f_C1R
QVFilterSobelVertMask_sFloatC1Worker::QVFilterSobelVertMask_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterSobelVertMask_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterSobelVertMask(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterLaplace_uCharC1Worker for IPP function ippiFilterLaplace_8u_C1R
QVFilterLaplace_uCharC1Worker::QVFilterLaplace_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterLaplace_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterLaplace(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterLaplace_sFloatC1Worker for IPP function ippiFilterLaplace_32f_C1R
QVFilterLaplace_sFloatC1Worker::QVFilterLaplace_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterLaplace_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterLaplace(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterGauss_uCharC1Worker for IPP function ippiFilterGauss_8u_C1R
QVFilterGauss_uCharC1Worker::QVFilterGauss_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterGauss_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterGauss(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterGauss_sFloatC1Worker for IPP function ippiFilterGauss_32f_C1R
QVFilterGauss_sFloatC1Worker::QVFilterGauss_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterGauss_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterGauss(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterGauss_uCharC3Worker for IPP function ippiFilterGauss_8u_C3R
QVFilterGauss_uCharC3Worker::QVFilterGauss_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterGauss_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	FilterGauss(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterGauss_sFloatC3Worker for IPP function ippiFilterGauss_32f_C3R
QVFilterGauss_sFloatC3Worker::QVFilterGauss_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterGauss_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	FilterGauss(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterHipass_uCharC1Worker for IPP function ippiFilterHipass_8u_C1R
QVFilterHipass_uCharC1Worker::QVFilterHipass_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterHipass_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterHipass(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterHipass_uCharC3Worker for IPP function ippiFilterHipass_8u_C3R
QVFilterHipass_uCharC3Worker::QVFilterHipass_uCharC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 3> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterHipass_uCharC3Worker::iterate()
	{
	const QVImage<uChar, 3> qvimage_pSrc = getPropertyValue< QVImage<uChar, 3> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 3> qvimage_pDst;

	FilterHipass(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterHipass_sFloatC1Worker for IPP function ippiFilterHipass_32f_C1R
QVFilterHipass_sFloatC1Worker::QVFilterHipass_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterHipass_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterHipass(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterHipass_sFloatC3Worker for IPP function ippiFilterHipass_32f_C3R
QVFilterHipass_sFloatC3Worker::QVFilterHipass_sFloatC3Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 3> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 3> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterHipass_sFloatC3Worker::iterate()
	{
	const QVImage<sFloat, 3> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 3> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 3> qvimage_pDst;

	FilterHipass(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 3> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterLowpass_uCharC1Worker for IPP function ippiFilterLowpass_8u_C1R
QVFilterLowpass_uCharC1Worker::QVFilterLowpass_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<uChar, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterLowpass_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<uChar, 1> qvimage_pDst;

	FilterLowpass(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<uChar, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVFilterLowpass_sFloatC1Worker for IPP function ippiFilterLowpass_32f_C1R
QVFilterLowpass_sFloatC1Worker::QVFilterLowpass_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< QVImage<sFloat, 1> >("qvimage_pDst", outputFlag);
	addProperty< IppiMaskSize >("mask", inputFlag);
	addProperty< QPoint >("destROIOffset", inputFlag);
	}

void QVFilterLowpass_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");
	const IppiMaskSize mask = getPropertyValue< IppiMaskSize > ("mask");
	const QPoint destROIOffset = getPropertyValue< QPoint > ("destROIOffset");

	QVImage<sFloat, 1> qvimage_pDst;

	FilterLowpass(qvimage_pSrc, qvimage_pDst, mask, destROIOffset);

	setPropertyValue< QVImage<sFloat, 1> >("qvimage_pDst", qvimage_pDst);
	}

// Worker QVSum_uCharC1Worker for IPP function ippiSum_8u_C1R
QVSum_uCharC1Worker::QVSum_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sDouble >("pSum", outputFlag);
	}

void QVSum_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");

	sDouble pSum;

	Sum(qvimage_pSrc, pSum);

	setPropertyValue< sDouble >("pSum", pSum);
	}

// Worker QVMean_uCharC1Worker for IPP function ippiMean_8u_C1R
QVMean_uCharC1Worker::QVMean_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sDouble >("pMean", outputFlag);
	}

void QVMean_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");

	sDouble pMean;

	Mean(qvimage_pSrc, pMean);

	setPropertyValue< sDouble >("pMean", pMean);
	}

// Worker QVMin_uCharC1Worker for IPP function ippiMin_8u_C1R
QVMin_uCharC1Worker::QVMin_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("pMin", outputFlag);
	}

void QVMin_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");

	uChar pMin;

	Min(qvimage_pSrc, pMin);

	setPropertyValue< uChar >("pMin", pMin);
	}

// Worker QVMin_sFloatC1Worker for IPP function ippiMin_32f_C1R
QVMin_sFloatC1Worker::QVMin_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("pMin", outputFlag);
	}

void QVMin_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");

	sFloat pMin;

	Min(qvimage_pSrc, pMin);

	setPropertyValue< sFloat >("pMin", pMin);
	}

// Worker QVMax_uCharC1Worker for IPP function ippiMax_8u_C1R
QVMax_uCharC1Worker::QVMax_uCharC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<uChar, 1> >("qvimage_pSrc", inputFlag);
	addProperty< uChar >("pMax", outputFlag);
	}

void QVMax_uCharC1Worker::iterate()
	{
	const QVImage<uChar, 1> qvimage_pSrc = getPropertyValue< QVImage<uChar, 1> > ("qvimage_pSrc");

	uChar pMax;

	Max(qvimage_pSrc, pMax);

	setPropertyValue< uChar >("pMax", pMax);
	}

// Worker QVMax_sFloatC1Worker for IPP function ippiMax_32f_C1R
QVMax_sFloatC1Worker::QVMax_sFloatC1Worker(QString name): QVWorker(name)
	{
	addProperty< QVImage<sFloat, 1> >("qvimage_pSrc", inputFlag);
	addProperty< sFloat >("pMax", outputFlag);
	}

void QVMax_sFloatC1Worker::iterate()
	{
	const QVImage<sFloat, 1> qvimage_pSrc = getPropertyValue< QVImage<sFloat, 1> > ("qvimage_pSrc");

	sFloat pMax;

	Max(qvimage_pSrc, pMax);

	setPropertyValue< sFloat >("pMax", pMax);
	}


